interface Function<T>
{
   void apply(T t);
}

public final class FL
{
   private final static Function<Integer> FEMPTY = 
      new Function<Integer>() { public void apply(Integer i) {} };

   public static void forEach(final int start, final int end, final boolean inc,
                              final Function<Integer> f)
   {
      ifThen(start != end, 
             new Function<Integer>()
             {
                @Override
                public void apply(Integer i)
                {
                   f.apply(start);
                   forEach(inc ? start + 1 : start - 1, end, inc, f);
                }
             });
   }

   public static void ifThen(boolean predicate, Function<Integer> onTrue)
   {
      ifThenElse(predicate, onTrue, FEMPTY);
   }

   public static void ifThenElse(boolean predicate, Function<Integer> onTrue,
                                 Function<Integer> onFalse)
   {
      ifThenElse1(predicate ? onTrue : onFalse);
   }

   private static void ifThenElse1(Function<Integer> f)
   {
      f.apply(0);
   }
}