import java.util.Comparator;

public class FuncSort
{
   public static void main(String[] args)
   {
      String[] innerplanets = { "Mercury", "Venus", "Earth", "Mars" };
      dump(innerplanets);
      sort(innerplanets, new Comparator<String>()
                         {
                            @Override
                            public int compare(String e1, String e2)
                            {
                               return e1.compareTo(e2);
                            }
                         });
      dump(innerplanets);
      sort(innerplanets, new Comparator<String>()
                         {
                            @Override
                            public int compare(String e1, String e2)
                            {
                               return e2.compareTo(e1);
                            }
                         });
      dump(innerplanets);
   }

   static <T> void dump(final T[] array)
   {
      FL.forEach(0, array.length, true,
                 new Function<Integer>()
                 {
                    @Override
                    public void apply(final Integer i)
                    {
                       System.out.println(array[i]);
                    }
                 });
      System.out.println();
   }

   static <T> void sort(final T[] array, final Comparator<T> cmp)
   {
      FL.forEach(0, array.length - 1, true,
                 new Function<Integer>()
                 {
                    @Override
                    public void apply(final Integer pass)
                    {
                       FL.forEach(array.length - 1, pass, false,
                                  new Function<Integer>()
                                  {
                                     @Override
                                     public void apply(final Integer i)
                                     {
                                        FL.ifThen(cmp.compare(array[i], 
                                                              array[pass]) < 0, 
                                                  new Function<Integer>()
                                                  {
                                                     @Override
                                                     public void apply(Integer z)
                                                     {
                                                        swap(array, i, pass);
                                                     }
                                                  });
                                     }
                                  });
                    }
                 });
   }

   static <T> void swap(T[] array, int i, int j)
   {
      T temp = array[i];
      array[i] = array[j];
      array[j] = temp;
   }
}