import java.util.Arrays;
import java.util.Comparator;

public class FuncSort
{
   public static void main(String[] args)
   {
      String[] innerplanets = { "Mercury", "Venus", "Earth", "Mars" };
      dump(innerplanets);
      sort(innerplanets, (e1, e2) -> e1.compareTo(e2));
      dump(innerplanets);
      sort(innerplanets, (e1, e2) -> e2.compareTo(e1));
      dump(innerplanets);
   }

   static <T> void dump(T[] array)
   {
      Arrays.stream(array).forEach(System.out::println);
      System.out.println();
   }

   static <T> void sort(T[] array, Comparator<T> cmp)
   {
      System.arraycopy(Arrays.stream(array).sorted(cmp).toArray(), 0, array, 0,
                       array.length);
   }
}